using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;


namespace tggm
{
    public class main
    {  
        public struct Assets
        {
            public static Sprite GrapplingGunLoaded;
            public static Sprite GrapplingGunUnloaded;
        }
        public static void Main()
        {
            Assets.GrapplingGunLoaded = ModAPI.LoadSprite("img/GrapplingGun.png");
            Assets.GrapplingGunUnloaded = ModAPI.LoadSprite("img/GrapplingGun_noBolt.png");
            
            #region Grappling Gun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"), 
                    NameOverride = "Grappling Gun - TGGM", 
                    DescriptionOverride = "This is the grappling gun. It shoots an hook that can attach to walls, soft object and yes... also people", 
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("img/GrapplingGun_thumb.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        var bp = Instance.GetComponent<ProjectileLauncherBehaviour>().barrelPosition;
                        GameObject.Destroy(Instance.GetComponent<ProjectileLauncherBehaviour>());
                        Instance.GetComponent<SpriteRenderer>().sprite = Assets.GrapplingGunLoaded;
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        var grappleGun = Instance.GetOrAddComponent<GrapplingGunBehaviour>();
                        grappleGun.barrelPosition = bp;
                        Instance.AddComponent<Optout>();
                    }
                } 
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"), 
                    NameOverride = "Grappling Gun (No Hook) - TGGM", 
                    DescriptionOverride = "Variant of the grappling gun that doesn't shoot a physical hook, but can attach to anything", 
                    CategoryOverride = ModAPI.FindCategory("Firearms"), 
                    AfterSpawn = (Instance) =>
                    {
                        var bp = Instance.GetComponent<FirearmBehaviour>().barrelPosition;
                        GameObject.Destroy(Instance.GetComponent<FirearmBehaviour>());
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        var grappleGun = Instance.GetOrAddComponent<RaycastGrapplingGunBehaviour>();
                        grappleGun.barrelPosition = bp;
                        Instance.AddComponent<Optout>();
                    }
                } 
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"), 
                    NameOverride = "Hook - TGGM", 
                    DescriptionOverride = "", 
                    CategoryOverride = null,
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<PhysicalBehaviour>().StabReleaseSpeedModifier = 0.01f;
                        var hook = Instance.AddComponent<HookBehaviour>();
                        Instance.AddComponent<Optout>();
                    }
                } 
            );
            #endregion            
        }
    }
}